SET TERM ^ ; 

CREATE PROCEDURE FILL_EXTERNAL (
    N INTEGER)
AS
BEGIN
  EXIT;
END^

CREATE PROCEDURE FILL_INTERNAL
AS
BEGIN
  EXIT;
END^

CREATE PROCEDURE SELECT_RANDOM (
    N INTEGER)
RETURNS (
    ID INTEGER)
AS
BEGIN
  EXIT;
END^

CREATE PROCEDURE TEST1
AS
BEGIN
  EXIT;
END^

CREATE PROCEDURE TEST2
AS
BEGIN
  EXIT;
END^

CREATE PROCEDURE TEST3
AS
BEGIN
  EXIT;
END^


SET TERM ; ^
CREATE TABLE T_EXTERNAL EXTERNAL 'G:\EXTERNAL.TXT' (
    ID CHAR(10),
    TSTAMP CHAR(24),
    CRLF CHAR(2));

CREATE TABLE T_INTERNAL (
    ID INTEGER NOT NULL,
    TSTAMP TIMESTAMP);



ALTER TABLE T_INTERNAL ADD CONSTRAINT PK_T_INTERNAL PRIMARY KEY (ID);

SET TERM ^ ;
ALTER PROCEDURE FILL_EXTERNAL (
    N INTEGER)
AS
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE K INTEGER;
DECLARE VARIABLE CRLF CHAR(2);
BEGIN
  CRLF='
';
  FOR SELECT ID, GETRANDOM(999999) FROM SELECT_RANDOM(:N) ORDER BY 2 INTO :ID, :K
    DO INSERT INTO T_EXTERNAL(ID,CRLF) VALUES(:ID, :CRLF);
END
^

ALTER PROCEDURE FILL_INTERNAL
AS
DECLARE VARIABLE I INTEGER;
DECLARE VARIABLE R INTEGER;
begin
  I=0;
  R=GETRANDOM(999999);
  WHILE (I<100000) DO
    BEGIN
    WHILE (EXISTS(SELECT ID FROM T_INTERNAL WHERE ID=:R))
      DO R=GETRANDOM(999999);
    INSERT INTO T_INTERNAL(ID) VALUES(:R);
    I=I+1;
    END
end
^

ALTER PROCEDURE SELECT_RANDOM (
    N INTEGER)
RETURNS (
    ID INTEGER)
AS
DECLARE VARIABLE I INTEGER;
DECLARE VARIABLE K INTEGER;
BEGIN
  K=0;
  FOR SELECT T.ID, GETRANDOM(999999) FROM T_INTERNAL T ORDER BY 2 INTO :ID, :I DO
    IF (K < N) THEN
      BEGIN
      SUSPEND;
      K=K+1;
      END
  SELECT MAX(ID) FROM T_INTERNAL INTO :I;
  WHILE (K < 100000) DO
    BEGIN
    SELECT (:I+GETRANDOM(999999)) FROM RDB$DATABASE INTO :ID;
    SUSPEND;
    K=K+1;
    END
END
^

ALTER PROCEDURE TEST1
AS
DECLARE VARIABLE ID INTEGER;
begin
  FOR SELECT ID FROM T_EXTERNAL INTO :ID DO
    IF (EXISTS(SELECT ID FROM T_INTERNAL WHERE ID=:ID))
      THEN UPDATE T_INTERNAL T SET T.TSTAMP=CURRENT_TIMESTAMP WHERE ID=:ID;
      ELSE INSERT INTO T_INTERNAL(ID) VALUES(:ID);
end
^

ALTER PROCEDURE TEST2
AS
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE K INTEGER;
begin
  FOR SELECT ID FROM T_EXTERNAL INTO :ID DO
    BEGIN
    K=NULL;
    FOR SELECT ID FROM T_INTERNAL WHERE ID=:ID INTO :K AS CURSOR TmpCursor DO
      UPDATE T_INTERNAL T SET T.TSTAMP=CURRENT_TIMESTAMP WHERE CURRENT OF TmpCursor;
    IF (K IS NULL) THEN INSERT INTO T_INTERNAL(ID) VALUES(:ID);
    END
end
^

ALTER PROCEDURE TEST3
AS
DECLARE VARIABLE ID INTEGER;
begin
  FOR SELECT ID FROM T_EXTERNAL INTO :ID DO
    BEGIN
    INSERT INTO T_INTERNAL(ID) VALUES(:ID);
    WHEN SQLCODE -803 DO UPDATE T_INTERNAL T SET T.TSTAMP=CURRENT_TIMESTAMP WHERE ID=:ID;
    END
end
^


SET TERM ; ^
